SystemOrganization addCategory: #'SUnit-Preload'!
SystemOrganization addCategory: #SUnit!
SystemOrganization addCategory: #'SUnit-UI'!
SystemOrganization addCategory: #'SUnit-Tests'!
SystemOrganization addCategory: #'SUnit-Extensions'!

Debugger subclass: #TestCaseDebugger
	instanceVariableNames: 'doneSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit'!

!TestCaseDebugger methodsFor: 'as yet unclassified' stamp: 'nk 1/22/2004 22:50'!
windowIsClosing
	super windowIsClosing.
	doneSemaphore ifNotNil: [ doneSemaphore signal ]! !

!TestCaseDebugger methodsFor: 'as yet unclassified' stamp: 'nk 1/22/2004 22:50'!
doneSemaphore: aSemaphore
	doneSemaphore _ aSemaphore.! !

!Object methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:58'!
sunitChanged: anAspect
 
        self changed: anAspect! !

!Object methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:58'!
sunitAddDependent: anObject
 
        self addDependent: anObject! !

Object subclass: #TestResource
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit'!

TestResource class
	instanceVariableNames: 'current'!

!TestResource class methodsFor: 'accessing' stamp: ''!
resources
	^#()
			! !

!TestResource class methodsFor: 'accessing' stamp: ''!
current: aTestResource

	current := aTestResource
			! !

!TestResource class methodsFor: 'testing' stamp: ''!
isAbstract
	"Override to true if a TestResource subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #TestResource
			! !

!TestResource methodsFor: 'accessing' stamp: ''!
description: aString

	description := aString
			! !

!TestResource methodsFor: 'testing' stamp: ''!
isAvailable
	"override to provide information on the
	readiness of the resource"
	
	^true
			! !

!TestResource methodsFor: 'accessing' stamp: ''!
name

	name isNil
		ifTrue: [^self printString].

	^name
			! !

!TestResource class methodsFor: 'testing' stamp: ''!
isUnavailable

	^self isAvailable not
			! !

!TestResource class methodsFor: 'creation' stamp: ''!
reset

	current notNil ifTrue: [
		[current tearDown] ensure: [
			current := nil]]
			! !

!TestResource methodsFor: 'printing' stamp: ''!
printOn: aStream

	aStream nextPutAll: self class printString
			! !

!TestResource methodsFor: 'running' stamp: ''!
setUp
	"Does nothing. Subclasses should override this
	to initialize their resource"
			! !

!TestResource methodsFor: 'initializing' stamp: ''!
initialize
	self setUp

			! !

!TestResource methodsFor: 'accessing' stamp: ''!
description

	description isNil
		ifTrue: [^''].

	^description
			! !

!TestResource methodsFor: 'accessing' stamp: ''!
resources
	^self class resources
			! !

TestResource subclass: #SimpleTestResource
	instanceVariableNames: 'runningState hasRun hasSetup hasRanOnce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!SimpleTestResource methodsFor: 'testing' stamp: ''!
hasSetup
	^hasSetup
			! !

!SimpleTestResource methodsFor: 'running' stamp: ''!
setUp
	
	self runningState: self startedStateSymbol.
	hasSetup := true
			! !

!SimpleTestResource methodsFor: 'running' stamp: ''!
setRun
	hasRun := true
			! !

!SimpleTestResource methodsFor: 'testing' stamp: ''!
hasRun
	^hasRun
			! !

!SimpleTestResource methodsFor: 'running' stamp: ''!
startedStateSymbol

	^#started
			! !

!SimpleTestResource methodsFor: 'running' stamp: ''!
stoppedStateSymbol

	^#stopped
			! !

!SimpleTestResource methodsFor: 'testing' stamp: ''!
isAvailable
	
	^self runningState == self startedStateSymbol
			! !

!SimpleTestResource methodsFor: 'accessing' stamp: ''!
runningState: aSymbol

	runningState := aSymbol
			! !

!SimpleTestResource methodsFor: 'accessing' stamp: ''!
runningState

	^runningState
			! !

!SimpleTestResource methodsFor: 'running' stamp: ''!
tearDown

	self runningState: self stoppedStateSymbol
			! !

!TestResource methodsFor: 'running' stamp: ''!
signalInitializationError
	^self class signalInitializationError
			! !

!TestResource methodsFor: 'testing' stamp: ''!
isUnavailable
	"override to provide information on the
	readiness of the resource"
	
	^self isAvailable not
			! !

!TestResource methodsFor: 'running' stamp: ''!
tearDown
	"Does nothing. Subclasses should override this
	to tear down their resource"
			! !

!TestResource methodsFor: 'accessing' stamp: ''!
name: aString

	name := aString
			! !

!TestResource class methodsFor: 'creation' stamp: ''!
signalInitializationError
	^TestResult signalErrorWith: 'Resource ' , self name , ' could not be initialized'
			! !

!TestResource class methodsFor: 'accessing' stamp: ''!
current

	current isNil
		ifTrue: [current := self new].

	^current
			! !

!TestResource class methodsFor: 'testing' stamp: ''!
isAvailable
	^self current notNil and: [self current isAvailable]
			! !

Object subclass: #TestResult
	instanceVariableNames: 'failures errors passed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit'!

!TestResult commentStamp: '<historical>' prior: 0!
This is a Collecting Parameter for the running of a bunch of tests. TestResult is an interesting object to subclass or substitute. #runCase: is the external protocol you need to reproduce. Kent has seen TestResults that recorded coverage information and that sent email when they were done.!

!TestResult class methodsFor: 'exceptions' stamp: ''!
failure
	^TestFailure
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:06'!
tests
	^(OrderedCollection new: self runCount)
		addAll: passed;
		addAll: failures;
		addAll: errors;
		yourself! !

!TestResult methodsFor: 'testing' stamp: ''!
hasFailures

	^self failures size > 0
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedFailures
	^ failures select: [:each | each shouldPass] ! !

!TestResult class methodsFor: 'exceptions' stamp: ''!
error
	^self exError
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedPassCount
	^ self unexpectedPasses size! !

!TestResult class methodsFor: 'exceptions' stamp: ''!
signalErrorWith: aString 
	self error sunitSignalWith: aString
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedErrors
	^ errors select: [:each | each shouldPass] ! !

!TestResult methodsFor: 'compatibility' stamp: 'JF 7/30/2003 16:08'!
passed
	^ self expectedPasses, self expectedDefects! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
expectedDefectCount
	^ self expectedDefects size! !

!TestResult methodsFor: 'accessing' stamp: ''!
correctCount
	"depreciated - use #passedCount"

	^self passedCount
			! !

!TestResult methodsFor: 'testing' stamp: ''!
isPassed: aTestCase

	^self passed includes: aTestCase
			! !

!TestResult methodsFor: 'compatibility' stamp: 'JF 7/30/2003 16:09'!
errors
	^ self unexpectedErrors! !

!TestResult methodsFor: 'printing' stamp: 'JF 7/30/2003 16:15'!
printOn: aStream
	aStream
		nextPutAll: self runCount printString;
		nextPutAll: ' run, ';
		nextPutAll: self expectedPassCount printString;
		nextPutAll: ' passes, ';
		nextPutAll: self expectedDefectCount printString;
		nextPutAll:' expected failures, ';
		nextPutAll: self unexpectedFailureCount printString;
		nextPutAll: ' failures, ';
		nextPutAll: self unexpectedErrorCount printString;
		nextPutAll:' errors, ';
		nextPutAll: self unexpectedPassCount printString;
		nextPutAll:' unexpected passes'.! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:07'!
runCount
	^ passed size + failures size + errors size! !

!TestResult methodsFor: 'compatibility' stamp: 'JF 7/30/2003 16:09'!
failures
	^ self unexpectedFailures, self unexpectedPasses ! !

!TestResult methodsFor: 'accessing' stamp: ''!
passedCount

	^self passed size
			! !

!TestResult class methodsFor: 'exceptions' stamp: ''!
resumableFailure
	^ResumableTestFailure
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
expectedPasses
	^ passed select: [:each | each shouldPass] ! !

!TestResult methodsFor: 'accessing' stamp: ''!
errorCount

	^self errors size
			! !

!TestResult class methodsFor: 'exceptions' stamp: ''!
exError
	^SUnitNameResolver errorObject
			! !

!TestResult class methodsFor: 'exceptions' stamp: ''!
signalFailureWith: aString 
	self failure sunitSignalWith: aString
			! !

!TestResult methodsFor: 'testing' stamp: ''!
isError: aTestCase

	^self errors includes: aTestCase
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
expectedDefects
	^ (errors, failures) select: [:each | each shouldPass not] ! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedErrorCount
	^ self unexpectedErrors size! !

!TestResult methodsFor: 'accessing' stamp: ''!
failureCount

	^self failures size
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
expectedPassCount
	^ self expectedPasses size! !

!TestResult methodsFor: 'accessing' stamp: ''!
defects
	^OrderedCollection new
		addAll: self errors;
		addAll: self failures; yourself
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedFailureCount
	^ self unexpectedFailures size! !

!TestResult methodsFor: 'testing' stamp: ''!
isFailure: aTestCase
	^self failures includes: aTestCase
			! !

!TestResult methodsFor: 'initialize-release' stamp: 'JF 7/30/2003 16:04'!
initialize
	passed _ OrderedCollection new.
	failures _ OrderedCollection new.
	errors _ OrderedCollection new.! !

!TestResult methodsFor: 'testing' stamp: 'JF 7/30/2003 14:04'!
hasPassed
	^self runCount = (self passedCount + self expectedDefectCount)! !

!TestResult methodsFor: 'running' stamp: 'JF 7/30/2003 16:05'!
runCase: aTestCase
	| testCasePassed |
	testCasePassed := true.
	[[aTestCase runCase] 
			sunitOn: self class failure
			do: 
				[:signal | 
				failures add: aTestCase.
				testCasePassed := false.
				signal sunitExitWith: false]]
					sunitOn: self class error
					do:
						[:signal |
						errors add: aTestCase.
						testCasePassed := false.
						signal sunitExitWith: false].
	testCasePassed ifTrue: [passed add: aTestCase]! !

!TestResult methodsFor: 'testing' stamp: ''!
hasErrors

	^self errors size > 0
			! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedPasses
	^ passed select: [:each | each shouldPass not] ! !

Object subclass: #TestSuite
	instanceVariableNames: 'tests resources name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit'!

!TestSuite commentStamp: '<historical>' prior: 0!
This is a Composite of Tests, either TestCases or other TestSuites. The common protocol is #run: aTestResult and the dependencies protocol!

!TestSuite methodsFor: 'dependencies' stamp: ''!
addDependentToHierachy: anObject
	self sunitAddDependent: anObject.
	self tests do: [ :each | each addDependentToHierachy: anObject]
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
resources
	resources isNil ifTrue: [resources := self defaultResources].
	^resources
			! !

!TestSuite methodsFor: 'running' stamp: ''!
run: aResult 
	self tests do: [:each | 
		self sunitChanged: each.
		each run: aResult]
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
addTests: aCollection 
	aCollection do: [:eachTest | self addTest: eachTest]
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
defaultResources
	^self tests 
		inject: Set new
		into: [:coll :testCase | 
			coll
				addAll: testCase resources;
				yourself]
			! !

!TestSuite class methodsFor: 'instance creation' stamp: ''!
named: aString

	^self new
		name: aString;
		yourself
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
addTest: aTest
	self tests add: aTest
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
resources: anObject
	resources := anObject
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
name: aString

	name := aString
			! !

!TestSuite methodsFor: 'dependencies' stamp: ''!
removeDependentFromHierachy: anObject
	self sunitRemoveDependent: anObject.
	self tests do: [ :each | each removeDependentFromHierachy: anObject]
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
tests
	tests isNil ifTrue: [tests := OrderedCollection new].
	^tests
			! !

!TestSuite methodsFor: 'accessing' stamp: ''!
name

	^name
			! !

!TestSuite methodsFor: 'running' stamp: ''!
run
	| result |
 	result := TestResult new.
	self resources do: [ :res |
		res isAvailable ifFalse: [^res signalInitializationError]].
	[self run: result] sunitEnsure: [self resources do: [:each | each reset]].
	^result
			! !

!Object methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:58'!
sunitRemoveDependent: anObject
 
        self removeDependent: anObject! !

Object subclass: #SUnitNameResolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Preload'!

!SUnitNameResolver class methodsFor: 'camp smalltalk' stamp: 'SSS 7/3/2000
11:11'!
classNamed: aSymbol

        ^Smalltalk
                at: aSymbol
                ifAbsent: [nil].! !

!SUnitNameResolver class methodsFor: 'camp smalltalk' stamp: 'jp 3/17/2003 13:56'!
errorObject
	^Error! !

!SUnitNameResolver class methodsFor: 'camp smalltalk' stamp: 'jp 3/17/2003 13:56'!
mnuExceptionObject
	^MessageNotUnderstood new! !

!SUnitNameResolver class methodsFor: 'camp smalltalk' stamp: 'jp 3/17/2003 13:56'!
notificationObject
	^Notification new! !

!SUnitNameResolver class methodsFor: 'camp smalltalk' stamp: 'jp 3/17/2003 13:56'!
defaultLogDevice
	^ Transcript! !

Object subclass: #TestCase
	instanceVariableNames: 'testSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit'!

!TestCase commentStamp: '<historical>' prior: 0!
A TestCase is a Command representing the future running of a test case. Create one with the class method #selector: aSymbol, passing the name of the method to be run when the test case runs.

When you discover a new fixture, subclass TestCase, declare instance variables for the objects in the fixture, override #setUp to initialize the variables, and possibly override# tearDown to deallocate any external resources allocated in #setUp.

When you are writing a test case method, send #assert: aBoolean when you want to check for an expected value. For example, you might say "self assert: socket isOpen" to test whether or not a socket is open at a point in a test.!

!TestCase methodsFor: 'running' stamp: ''!
run
	| result |
	result := TestResult new.
	self run: result.
	^result
			! !

!TestCase methodsFor: 'running' stamp: ''!
isLogging
	"By default, we're not logging failures. If you override this in 
	a subclass, make sure that you override #failureLog"
	^false
			! !

!TestCase methodsFor: 'running' stamp: ''!
debug
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[(self class selector: testSelector) runCase] 
		sunitEnsure: [self resources do: [:each | each reset]]
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
shouldnt: aBlock
	self deny: aBlock value
			! !

!TestCase methodsFor: 'dependencies' stamp: ''!
addDependentToHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

!TestCase methodsFor: 'accessing' stamp: ''!
selector
	^testSelector
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
resources
	| allResources resourceQueue |
	allResources := Set new.
	resourceQueue := OrderedCollection new.
	resourceQueue addAll: self class resources.
	[resourceQueue isEmpty] whileFalse: [
		| next |
		next := resourceQueue removeFirst.
		allResources add: next.
		resourceQueue addAll: next resources].
	^allResources
			! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 10:59'!
addTestsFor: classNameString toSuite: suite

	| cls  |
	cls _ Smalltalk at: classNameString ifAbsent: [ ^suite ].
	^cls isAbstract 
		ifTrue:  [
			cls allSubclasses do: [ :each |
				each isAbstract ifFalse: [
					each addToSuiteFromSelectors: suite ] ].
			suite]
		ifFalse: [ cls addToSuiteFromSelectors: suite ]
! !

!TestCase class methodsFor: 'building suites' stamp: ''!
buildSuiteFromAllSelectors

	^self buildSuiteFromMethods: self allTestSelectors
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
shouldnt: aBlock description: aString
	self deny: aBlock value description: aString
			! !

!TestCase class methodsFor: 'building suites' stamp: ''!
buildSuiteFromLocalSelectors

	^self buildSuiteFromMethods: self testSelectors
			! !

TestCase subclass: #ExampleSetTest
	instanceVariableNames: 'full empty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testOccurrences
	self assert: (empty occurrencesOf: 0) = 0.
	self assert: (full occurrencesOf: 5) = 1.
	full add: 5.
	self assert: (full occurrencesOf: 5) = 1
			! !

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testAdd
	empty add: 5.
	self assert: (empty includes: 5)
			! !

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testIncludes
	self assert: (full includes: 5).
	self assert: (full includes: #abc)
			! !

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testIllegal
	self 
		should: [empty at: 5] 
		raise: TestResult error.
	self 
		should: [empty at: 5 put: #abc] 
		raise: TestResult error
			! !

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testRemove
	full remove: 5.
	self assert: (full includes: #abc).
	self deny: (full includes: 5)
			! !

!ExampleSetTest methodsFor: 'testing' stamp: ''!
testGrow
	empty addAll: (1 to: 100).
	self assert: empty size = 100
			! !

!ExampleSetTest methodsFor: 'running' stamp: ''!
setUp
	empty := Set new.
	full := Set with: 5 with: #abc
			! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 16:37'!
addToSuiteFromSelectors: suite
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ])! !

TestCase subclass: #LongTestCaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Extensions'!

!LongTestCaseTest methodsFor: 'testing' stamp: 'sd 9/25/2004 14:12'!
testLongTestCaseRun
	"self debug: #testLongTestCaseRun"
	"self run: #testLongTestCaseRun"

	LongTestCase runLongTestCases.
	LongTestCaseTestUnderTest markAsNotRun.
	self deny: LongTestCaseTestUnderTest hasRun.
	LongTestCaseTestUnderTest suite run.
	self assert: LongTestCaseTestUnderTest hasRun.


	! !

!LongTestCaseTest methodsFor: 'testing' stamp: 'sd 9/25/2004 14:12'!
testLongTestCaseDoNotRun
	"self debug: #testLongTestCaseDoNotRun"
	"self run: #testLongTestCaseDoNotRun"

	LongTestCase doNotRunLongTestCases.
	LongTestCaseTestUnderTest markAsNotRun.
	self deny: LongTestCaseTestUnderTest hasRun.
	LongTestCaseTestUnderTest suite run.
	self deny: LongTestCaseTestUnderTest hasRun.


	! !

TestCase subclass: #ResumableTestFailureTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
isLogging
	^false
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
testResumable
	| result suite |
	suite := TestSuite new.
	suite addTest: (self class selector: #errorTest).
	suite addTest: (self class selector: #regularTestFailureTest).
	suite addTest: (self class selector: #resumableTestFailureTest).
	suite addTest: (self class selector: #okTest).
	result := suite run.
	self assert: result failures size = 2;
		assert: result errors size = 1
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
regularTestFailureTest
	self assert: false description: 'You should see me'
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
failureLog
	^SUnitNameResolver defaultLogDevice
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
failureTest
	self
		assert: false description: 'You should see me' resumable: true; 
		assert: false description: 'You should see me too' resumable: true; 
		assert: false description: 'You should see me last' resumable: false; 
		assert: false description: 'You should not see me' resumable: true
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
errorTest
	1 zork
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
okTest
	self assert: true
			! !

!ResumableTestFailureTestCase methodsFor: 'as yet unclassified' stamp: ''!
resumableTestFailureTest
	self
		assert: false description: 'You should see me' resumable: true; 
		assert: false description: 'You should see me too' resumable: true; 
		assert: false description: 'You should see me last' resumable: false; 
		assert: false description: 'You should not see me' resumable: true
			! !

!TestCase class methodsFor: 'instance creation' stamp: ''!
selector: aSymbol

	^self new setTestSelector: aSymbol
			! !

!TestCase methodsFor: 'private' stamp: ''!
setTestSelector: aSymbol
	testSelector := aSymbol
			! !

!TestCase methodsFor: 'running' stamp: ''!
run: aResult
	aResult runCase: self
			! !

!TestCase methodsFor: 'private' stamp: 'nk 5/11/2003 10:32'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: aString
	^[aBlock value.
 	false] sunitOn: anExceptionalEvent
		do: [:ex | ex sunitExitWith: (ex description includesSubString: aString) not ]
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
			! !

!TestCase methodsFor: 'accessing' stamp: 'nk 5/11/2003 10:34'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString) not
		description: aString
! !

!TestCase class methodsFor: 'testing' stamp: ''!
shouldInheritSelectors
	"I should inherit from an Abstract superclass but not from a concrete one by default, unless I have no testSelectors in which case I must be expecting to inherit them from my superclass.  If a test case with selectors wants to inherit selectors from a concrete superclass, override this to true in that subclass."

	^self superclass isAbstract
		or: [self testSelectors isEmpty]

"$QA Ignore:Sends system method(superclass)$"
			! !

!TestCase class methodsFor: 'instance creation' stamp: ''!
run: aSymbol

	^(self selector: aSymbol) run
			! !

!TestCase class methodsFor: 'testing' stamp: ''!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #TestCase
			! !

!TestCase methodsFor: 'private' stamp: 'nk 5/11/2003 10:23'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: aString
	^[aBlock value.
 	false] sunitOn: anExceptionalEvent
		do: [:ex | ex sunitExitWith: (ex description includesSubString: aString) ]
			! !

!TestCase methodsFor: 'accessing' stamp: 'nk 5/11/2003 10:34'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString) not
		description: aString
! !

!TestCase methodsFor: 'accessing' stamp: ''!
assert: aBoolean

	aBoolean ifFalse: [self signalFailure: 'Assertion failed']
			! !

!TestCase methodsFor: 'testing' stamp: 'JF 7/30/2003 13:39'!
shouldPass
	"Unless the selector is in the list we get from #expectedFailures, we expect it to pass"
	^ (self expectedFailures includes: testSelector) not! !

!TestCase methodsFor: 'accessing' stamp: ''!
assert: aBoolean description: aString
	aBoolean ifFalse: [
		self logFailure: aString.
		TestResult failure sunitSignalWith: aString]
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
deny: aBoolean description: aString
	self assert: aBoolean not description: aString
			! !

!TestCase methodsFor: 'running' stamp: ''!
failureLog	
	^SUnitNameResolver defaultLogDevice

			! !

!TestCase methodsFor: 'private' stamp: ''!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	^[aBlock value.
 	false] sunitOn: anExceptionalEvent
		do: [:ex | ex sunitExitWith: true]
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
should: aBlock
	self assert: aBlock value
			! !

TestCase subclass: #SimpleTestResourceTestCase
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
setUp
	resource := SimpleTestResource current
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
setRun
	resource setRun
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
testResourceInitRelease
	| result suite error failure |
	suite := TestSuite new.
	suite addTest: (error := self class selector: #error).
	suite addTest: (failure := self class selector: #fail).
	suite addTest: (self class selector: #dummy).
	result := suite run.
	self assert: resource hasSetup
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
dummy
	self assert: true
			! !

!SimpleTestResourceTestCase class methodsFor: 'as yet unclassified' stamp: ''!
resources
	^Set new add: SimpleTestResource; yourself
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
testResourcesCollection
	| collection |
	collection := self resources.
	self assert: collection size = 1
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
fail
	self assert: false
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
testRan
	| case |

	case := self class selector: #setRun.
	case run.
	self assert: resource hasSetup.
	self assert: resource hasRun
			! !

!SimpleTestResourceTestCase methodsFor: 'as yet unclassified' stamp: ''!
error
	'foo' odd
			! !

!TestCase methodsFor: 'running' stamp: ''!
logFailure: aString
	self isLogging ifTrue: [
		self failureLog 
			cr; 
			nextPutAll: aString; 
			flush]
			! !

!TestCase methodsFor: 'accessing' stamp: 'nk 5/11/2003 10:32'!
should: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString)
		description: aString
! !

!TestCase methodsFor: 'running' stamp: 'nk 1/22/2004 22:50'!
runCaseAsFailure: aSemaphore
	self setUp.
	self openDebuggerOnFailingTestMethod: aSemaphore.! !

!TestCase methodsFor: 'running' stamp: ''!
tearDown
			! !

!TestCase methodsFor: 'printing' stamp: ''!
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: '>>#';
		nextPutAll: testSelector
			! !

!TestCase class methodsFor: 'accessing' stamp: ''!
testSelectors

	^self sunitSelectors select: [:each | 'test*' sunitMatch: each]
			! !

!TestCase class methodsFor: 'instance creation' stamp: ''!
debug: aSymbol

	^(self selector: aSymbol) debug
			! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 10:52'!
buildSuiteFromMethods: testMethods 
	| suite |
	suite _ (TestSuite new)
				name: self name asString;
				yourself.
	^self addToSuite: suite fromMethods: testMethods! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 12/23/2002 07:40'!
buildSuite
	| suite |
	suite _ TestSuite new.
	^ self isAbstract
		ifTrue: [
			suite name: self name asString.
			self allSubclasses
				do: [:each | each isAbstract
						ifFalse: [each addToSuiteFromSelectors: suite]].
			suite]
		ifFalse: [self addToSuiteFromSelectors: suite]! !

!TestCase methodsFor: 'accessing' stamp: ''!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not 		description: aString
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
assert: aBoolean description: aString resumable: resumableBoolean 
	| exception |
	aBoolean
		ifFalse: 
			[self logFailure: aString.
			exception := resumableBoolean
						ifTrue: [TestResult resumableFailure]
						ifFalse: [TestResult failure].
			exception sunitSignalWith: aString]
			! !

TestCase subclass: #LongTestCase
	instanceVariableNames: ''
	classVariableNames: 'DoNotRunLongTestCases'
	poolDictionaries: ''
	category: 'SUnit-Extensions'!

!LongTestCase class methodsFor: 'testing' stamp: 'md 11/14/2004 21:34'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #LongTestCase
			! !

LongTestCase subclass: #LongTestCaseTestUnderTest
	instanceVariableNames: ''
	classVariableNames: 'RunStatus'
	poolDictionaries: ''
	category: 'SUnit-Extensions'!

!LongTestCaseTestUnderTest class methodsFor: 'Accessing' stamp: 'md 11/14/2004 21:37'!
markAsNotRun

	^ RunStatus := false! !

!LongTestCaseTestUnderTest class methodsFor: 'Accessing' stamp: 'sd 9/25/2004 14:02'!
hasRun

	^ RunStatus! !

!LongTestCaseTestUnderTest methodsFor: 'testing' stamp: 'md 11/14/2004 21:30'!
testWhenRunMarkTestedToTrue


	RunStatus := true.! !

!LongTestCase class methodsFor: 'accessing' stamp: 'md 11/14/2004 21:31'!
runLongTestCases

	DoNotRunLongTestCases := false.! !

!LongTestCase class methodsFor: 'accessing' stamp: 'sd 9/25/2004 12:57'!
doNotRunLongTestCases

	DoNotRunLongTestCases := true.! !

!LongTestCase class methodsFor: 'class initialization' stamp: 'sd 9/25/2004 12:57'!
initialize

	self doNotRunLongTestCases! !

!LongTestCase class methodsFor: 'instance creation' stamp: 'md 11/14/2004 22:14'!
buildSuite
	| suite |
	suite _ TestSuite new.
	DoNotRunLongTestCases ifFalse: [
		self addToSuiteFromSelectors: suite].
	^suite! !

!TestCase methodsFor: 'dependencies' stamp: ''!
removeDependentFromHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

TestCase subclass: #TestExceptionSubstrings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!TestExceptionSubstrings methodsFor: 'as yet unclassified' stamp: 'nk 5/11/2003 10:34'!
testNoExceptionWithMatchingString
	self shouldnt: [ Object obsolete ] raise: Error whoseDescriptionIncludes: 'Zero' description: 'tested obsoleting Object'! !

!TestExceptionSubstrings methodsFor: 'as yet unclassified' stamp: 'nk 5/11/2003 10:35'!
testNoExceptionWithNoMatchingString
	self shouldnt: [ Object obsolete ] raise: Error whoseDescriptionDoesNotInclude: 'NOT' description: 'tested obsoleting Object'! !

!TestExceptionSubstrings methodsFor: 'as yet unclassified' stamp: 'nk 5/11/2003 10:33'!
testExceptionWithoutMatchingString
	self should: [ Object obsolete ] raise: Error whoseDescriptionDoesNotInclude: 'Zero' description: 'tested obsoleting Object'! !

!TestExceptionSubstrings methodsFor: 'as yet unclassified' stamp: 'nk 5/11/2003 10:33'!
testExceptionWithMatchingString
	self should: [ Object obsolete ] raise: Error whoseDescriptionIncludes: 'NOT obsolete' description: 'tested obsoleting Object'! !

!TestCase methodsFor: 'accessing' stamp: 'nk 5/11/2003 10:24'!
should: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString)
		description: aString
! !

!TestCase methodsFor: 'accessing' stamp: ''!
signalFailure: aString
	TestResult failure sunitSignalWith: aString! !

!TestCase methodsFor: 'accessing' stamp: ''!
should: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
should: aBlock description: aString
	self assert: aBlock value description: aString
			! !

!TestCase class methodsFor: 'instance creation' stamp: ''!
suite

	^self buildSuite
			! !

!TestCase class methodsFor: 'accessing' stamp: ''!
sunitVersion
	^'3.1'
			! !

!TestCase methodsFor: 'running' stamp: 'nk 1/22/2004 22:49'!
debugAsFailure
	| semaphore |
	semaphore := Semaphore new.
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[semaphore wait. 
	self tearDown.
	self resources do: [:each | each reset]] fork.
	(self class selector: testSelector) runCaseAsFailure: semaphore.! !

!TestCase methodsFor: 'running' stamp: ''!
runCase

	[self setUp.
	self performTest] sunitEnsure: [self tearDown]
			! !

!TestCase methodsFor: 'private' stamp: ''!
performTest

	self perform: testSelector sunitAsSymbol
			! !

!TestCase class methodsFor: 'building suites' stamp: ''!
suiteClass
	^TestSuite
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
			! !

!TestCase class methodsFor: 'accessing' stamp: ''!
allTestSelectors

	^self sunitAllSelectors select: [:each | 'test*' sunitMatch: each]
			! !

!TestCase class methodsFor: 'accessing' stamp: ''!
resources

	^#()
			! !

!TestCase class methodsFor: 'building suites' stamp: ''!
buildSuiteFromSelectors

	^self shouldInheritSelectors
		ifTrue: [self buildSuiteFromAllSelectors]
		ifFalse: [self buildSuiteFromLocalSelectors]
			! !

!TestCase methodsFor: 'running' stamp: 'nk 1/22/2004 22:54'!
openDebuggerOnFailingTestMethod: semaphore
	| guineaPig context compiledMethod debugger |
	compiledMethod _ self class lookupSelector: self selector.
	guineaPig _ [ self performTest ] newProcess.
	context _ guineaPig suspendedContext.
	debugger _ TestCaseDebugger new
		process: guineaPig
		controller: ((Smalltalk isMorphic not and: [ScheduledControllers inActiveControllerProcess])
				ifTrue: [ScheduledControllers activeController]
				ifFalse: [nil])
		context: context
		isolationHead: nil.
	debugger doneSemaphore: semaphore.
	debugger openFullNoSuspendLabel: 'Debug failed test ', self printString.
	[debugger interruptedContext method == compiledMethod]
		whileFalse: [debugger send].
! !

!TestCase methodsFor: 'running' stamp: ''!
setUp
			! !

!TestCase methodsFor: 'testing' stamp: 'JF 7/30/2003 13:40'!
expectedFailures
	^ Array new! !

TestCase subclass: #SUnitTest
	instanceVariableNames: 'hasRun hasSetup hasRanOnce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!SUnitTest commentStamp: '<historical>' prior: 0!
This is both an example of writing tests and a self test for the SUnit. The tests 
here are pretty strange, since you want to make sure things blow up. You should 
not generally have to write tests this complicated in structure, although they 
will be far more complicated in terms of your own objects- more assertions, more 
complicated setup. Kent says: "Never forget, however, that if the tests are hard 
to write, something is probably wrong with the design".!

!SUnitTest methodsFor: 'testing' stamp: ''!
testDialectLocalizedException

	self
		should: [TestResult signalFailureWith: 'Foo']
		raise: TestResult failure.
	self
		should: [TestResult signalErrorWith: 'Foo']
		raise: TestResult error.

			! !

!SUnitTest methodsFor: 'private' stamp: ''!
fail
	self assert: false
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testRunning

	(SUnitDelay forSeconds: 2) wait
			! !

!SUnitTest methodsFor: 'private' stamp: ''!
noop
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testAssert
	self assert: true.
	self deny: false
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testSuite

	| suite result |

	suite := TestSuite new.
	suite 
		addTest: (self class selector: #noop);
		addTest: (self class selector: #fail);
		addTest: (self class selector: #error).

	result := suite run.

	self
		assertForTestResult: result
		runCount: 3
		passed: 1
		failed: 1
		errors: 1
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testRan

	| case |

	case := self class selector: #setRun.
	case run.
	self assert: case hasSetup.
	self assert: case hasRun
			! !

!SUnitTest methodsFor: 'accessing' stamp: ''!
hasSetup
	^hasSetup
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testError

	| case result |

	case := self class selector: #error.
	result := case run.
	self
		assertForTestResult: result
		runCount: 1
		passed: 0
		failed: 0
		errors: 1.

	case := self class selector: #errorShouldntRaise.
	result := case run.
	self 
		assertForTestResult: result
		runCount: 1
		passed: 0
		failed: 0
		errors: 1
			! !

!SUnitTest methodsFor: 'private' stamp: ''!
error
	3 zork
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testShould

	self
		should: [true];
		shouldnt: [false]
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testException

	self
		should: [self error: 'foo']
		raise: TestResult error
			! !

!SUnitTest methodsFor: 'running' stamp: ''!
setUp
	hasSetup := true
			! !

!SUnitTest methodsFor: 'private' stamp: ''!
setRun
	hasRun := true
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testDefects
	| result suite error failure |
	suite := TestSuite new.
	suite addTest: (error := self class selector: #error).
	suite addTest: (failure := self class selector: #fail).
	result := suite run.
	self assert: result defects asArray = (Array with: error with: failure).
	self
		assertForTestResult: result
		runCount: 2
		passed: 0
		failed: 1
		errors: 1
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testIsNotRerunOnDebug

	| case |

	case := self class selector: #testRanOnlyOnce.
	case run.
	case debug
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testFail

	| case result |

	case := self class selector: #fail.
	result := case run.

	self
		assertForTestResult: result
		runCount: 1
		passed: 0
		failed: 1
		errors: 0
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
errorShouldntRaise
	self 
		shouldnt: [self someMessageThatIsntUnderstood] 
		raise: SUnitNameResolver notificationObject
			! !

!SUnitTest methodsFor: 'accessing' stamp: ''!
hasRun
	^hasRun
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testResult

	| case result |

	case := self class selector: #noop.
	result := case run.

	self
		assertForTestResult: result
		runCount: 1
		passed: 1
		failed: 0
		errors: 0
			! !

!SUnitTest methodsFor: 'private' stamp: ''!
assertForTestResult: aResult runCount: aRunCount passed: aPassedCount failed: aFailureCount errors: anErrorCount

	self
		assert: aResult runCount = aRunCount;
		assert: aResult passedCount = aPassedCount;
		assert: aResult failureCount = aFailureCount;
		assert: aResult errorCount = anErrorCount
			! !

!SUnitTest methodsFor: 'testing' stamp: ''!
testRanOnlyOnce

	self assert: hasRanOnce ~= true.
	hasRanOnce := true
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
deny: aBoolean

	self assert: aBoolean not
			! !

!TestCase methodsFor: 'accessing' stamp: ''!
deny: aBoolean description: aString resumable: resumableBoolean 
	self
		assert: aBoolean not
		description: aString
		resumable: resumableBoolean
			! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 10:51'!
addToSuite: suite fromMethods: testMethods 
	testMethods do:  [ :selector | 
			suite addTest: (self selector: selector) ].
	^suite! !

Model subclass: #TestRunner
	instanceVariableNames: 'result details passFail failures errors tests passFailText detailsText lastPass testsList selectedFailureTest selectedErrorTest selectedSuite filter selectedSuites running completedTests totalTests progress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestRunner commentStamp: 'nk 8/6/2003 10:02' prior: 0!
This is a user interface for the SUnit TestCase and TestSuite classes.
It lets you run tests in the background, and you can select subsets to run.!

!TestRunner methodsFor: 'interface opening' stamp: 'nk 4/21/2002 16:49'!
openAsMorph
	"TestRunner new openAsMorph"
	^self morphicWindow openInWorld.
! !

!TestRunner methodsFor: 'accessing' stamp: 'nk 4/22/2002 10:52'!
result
	^result
! !

!TestRunner methodsFor: 'processing' stamp: 'ar 3/1/2004 03:29'!
runOneTest
	| testSuite |
	Cursor execute showWhile: [
		self runWindow.
		selectedSuite isZero ifTrue: [ ^ self displayPassFail: 'No Test Suite Selected' ].
		testSuite _  TestSuite new name: 'TestRunner Suite'.
		self addTestsFor: (tests at: selectedSuite) toSuite: testSuite.
		self runSuite: testSuite.
	]! !

!TestRunner methodsFor: 'test processing' stamp: 'jp 3/17/2003 14:00'!
errorLog
	^SUnitNameResolver defaultLogDevice! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 8/6/2003 09:57'!
morphicWindow
	"TestRunner new openAsMorph"
	| upperRow lowerPanes fracYRatio divider window |
	window _ SystemWindow labelled: self windowLabel.
	window model: self.
	upperRow _ self buildUpperControls.
	lowerPanes _ self buildLowerPanes.
	fracYRatio _ 0.25.
	window
		addMorph: upperRow
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 1 @ fracYRatio) offsets: (0@0 corner: 0@0)).
	divider _ BorderedSubpaneDividerMorph forBottomEdge.
	Preferences alternativeWindowLook
		ifTrue: [divider hResizing: #spaceFill;
				 color: Color transparent;
				 borderColor: #raised;
				 borderWidth: 1].
	window
		addMorph: divider
		fullFrame: (LayoutFrame
				fractions: (0 @ fracYRatio corner: 1 @ fracYRatio)
				offsets: (0 @ 0 corner: 0 @ 2)).

	window
		addMorph: lowerPanes
		fullFrame: (LayoutFrame fractions: (0 @ fracYRatio extent: 1 @ (1 - fracYRatio)) offsets: (0@0 corner: 0@0)).
	self refreshWindow.
	window extent: 460 @ 400.
	^window! !

!TestRunner methodsFor: 'interface opening' stamp: 'ar 3/3/2004 00:04'!
updateProgressWatcher: text
	progress subLabel:  text.
	progress done: (completedTests / totalTests) asFloat.
	World doOneCycleNow.
	running ifFalse:[self error:'Run stopped'].! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 15:41'!
refreshButtonLabel
        ^ 'Refresh'
! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:29'!
runButtonColor
	^ Color green lighter! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 8/6/2003 08:36'!
buildErrorsList
	^PluggableListMorph
				on: self
				list: #errorsList
				selected: #selectedErrorTest
				changeSelected: #debugErrorTest:.
! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:38'!
displayDetails: aString
        details := aString.
        self changed: #details! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 18:39'!
tests
        ^ tests! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 19:28'!
buildRefreshButton
	| refreshButton |
	refreshButton _ PluggableButtonMorph
				on: self
				getState: #refreshButtonState
				action: #refreshTests
				label: #refreshButtonLabel.
	refreshButton color: self runButtonColor;
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 useRoundedCorners.
	refreshButton onColor: self runButtonColor offColor: self runButtonColor.
	^ refreshButton! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:29'!
runButtonOffColor
	^ Color yellow lighter! !

!TestRunner class methodsFor: 'parts bin' stamp: 'nk 8/6/2003 09:47'!
descriptionForPartsBin
	^self partName: 'Test Runner'
		categories: #(Tools)
		documentation: 'SUnit Test UI'
! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 8/6/2003 10:54'!
removeProgressWatcher
	progress ifNil: [ ^self ].
	progress delete.
	self dependents first updatePanesFromSubmorphs.
	progress _ nil
! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:01'!
selectedFailureTest

        ^selectedFailureTest! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:57'!
windowLabel
	^ 'SUnit Test Runner'! !

!TestRunner class methodsFor: 'new-morph participation' stamp: 'nk 4/26/2002 08:57'!
initializedInstance
	^self new morphicWindow extent: 400@400
! !

!TestRunner methodsFor: 'menus' stamp: 'nk 12/19/2002 08:42'!
setFilter
	filter _ FillInTheBlank request: 'Pattern for added test cases (#* OK)' initialAnswer: '*'.
	(filter endsWith: '*') ifFalse: [ filter _ filter, '*' ].
	selectedSuites _ (tests asOrderedCollection with: selectedSuites collect: [ :ea :sel |
		sel or: [ filter match: ea asString ]
	]).
	selectedSuite _ selectedSuites indexOf: true ifAbsent: [0].
	self changed: #allSelections.
! !

!TestRunner methodsFor: 'test processing' stamp: 'jp 3/17/2003 14:00'!
showResultDefects

	(self result failureCount > 0)
		ifTrue: [
			self errorLog cr; show: '---- SUnit ----- Failures ----'.
			self result failures do: [:failure |
				self errorLog crtab; show: failure printString]].
	(self result errorCount > 0)
		ifTrue: [
			self errorLog cr; show: '---- SUnit ------- Errors ----'.
			self result errors do: [:error |
				self errorLog crtab; show: error printString]].! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:25'!
details

        ^details! !

!TestRunner methodsFor: 'updating' stamp: 'nk 8/6/2003 09:07'!
runWindow
	| pc |
	pc _ self defaultBackgroundColor.
	passFailText isMorph
		ifTrue: [passFailText color: pc.
			detailsText color: pc]
		ifFalse: [passFailText insideColor: pc.
			detailsText insideColor: pc].
	self updateErrors: TestResult new.
	self updateFailures: TestResult new.
	self displayPassFail: 'Running...'.
	self displayDetails: '...'! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 19:28'!
buildRunButton
	| runButton |
	runButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runTests
				label: #runButtonLabel.
	runButton color: self runButtonColor;
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 useRoundedCorners.
	runButton onColor: self runButtonColor offColor: self runButtonOffColor.
	^ runButton! !

!TestRunner methodsFor: 'interface opening' stamp: 'md 11/10/2004 13:36'!
buildDetailsText
	detailsText _ PluggableTextMorph
				on: self
				text: #details
				accept: nil.
	detailsText hideScrollBarsIndefinitely.
	^detailsText! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 17:36'!
displayPassFail: aString
        passFail := aString.
        self changed: #passFail! !

!TestRunner methodsFor: 'updating' stamp: 'jp 3/17/2003 10:51'!
displayFailures: anOrderedCollection

        failures := anOrderedCollection.
        self changed: #failuresList! !

!TestRunner methodsFor: 'initialize' stamp: 'md 11/14/2004 21:04'!
testCases

	Preferences testRunnerShowAbstractClasses ifTrue: [
			^ TestCase allSubclasses.
	].
	^ TestCase allSubclasses reject: [:cls | cls isAbstract]! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 15:41'!
runButtonLabel
        ^ 'Run All'
! !

!TestRunner methodsFor: 'processing' stamp: 'nk 12/15/2002 09:46'!
selectedSuite: anInteger
	anInteger > 0 ifTrue: [ | selected |
		selected _ selectedSuite ~= anInteger.
		selectedSuites at: anInteger put: selected.
	] ifFalse: [
		"selectedSuite > 0 ifTrue: [ selectedSuites at: selectedSuite put: false ]."
	].
	selectedSuite _ anInteger.
	selectedFailureTest _ 0.
	selectedErrorTest _ 0.
	self changed: #selectedFailureTest.             "added rew"
	self changed: #selectedErrorTest.               "added rew" 
	self changed: #selectedSuite.
	self changed: #allSelections.
! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:31'!
failColor
	^ Color yellow lighter! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 15:41'!
runOneButtonLabel
        ^ 'Run One'
! !

!TestRunner class methodsFor: 'new-morph participation' stamp: 'nk 4/26/2002 08:57'!
newStandAlone
	^self new morphicWindow
! !

!TestRunner methodsFor: 'updating' stamp: 'jp 3/17/2003 13:49'!
updateErrors: aTestResult

        self displayErrors: aTestResult errors! !

!TestRunner methodsFor: 'accessing' stamp: 'jp 3/17/2003 13:49'!
errors

        ^errors! !

!TestRunner methodsFor: 'processing' stamp: 'jp 3/17/2003 10:46'!
debugFailureTest: anInteger

        (anInteger ~= 0)
                ifTrue: [(self failures at: anInteger) debugAsFailure].

        selectedFailureTest _ anInteger.
        selectedErrorTest _ 0.
        self changed: #selectedErrorTest.
        self changed: #selectedFailureTest.
! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedSuite

        ^selectedSuite! !

!TestRunner methodsFor: 'accessing' stamp: 'nk 4/21/2002 11:14'!
listSelectionAt: index put: aBoolean
	^selectedSuites at: index put: aBoolean
! !

!TestRunner methodsFor: 'recording' stamp: 'nk 4/22/2002 19:49'!
recordInteractionFor: aClass
	aClass recordInteraction.
! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 13:59'!
refreshButtonState

        ^true! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/12/2000 18:12'!
formatTime: aTime
        aTime hours > 0 ifTrue: [^aTime hours printString , 'h'].
        aTime minutes > 0 ifTrue: [^aTime minutes printString , 'min'].
        ^aTime seconds printString , ' sec'! !

!TestRunner methodsFor: 'menus' stamp: 'nk 4/21/2002 12:17'!
perform: aSelector orSendTo: otherTarget
	^((self respondsTo: aSelector) ifTrue: [ self ] ifFalse: [ otherTarget ]) perform: aSelector
! !

!TestRunner methodsFor: 'menus' stamp: 'ar 3/3/2004 00:01'!
terminateRun
	running := false.! !

!TestRunner methodsFor: 'updating' stamp: 'jp 3/17/2003 10:52'!
updateFailures: aTestResult

        self displayFailures: aTestResult failures asOrderedCollection! !

!TestRunner methodsFor: 'test processing' stamp: 'nk 4/22/2002 10:54'!
showResultSummary

	| message summary |
	message := (self result runCount = self result correctCount)
		ifTrue: [self successMessage]
		ifFalse: [self failureMessage].
	Transcript crtab; show: message.
	summary :=
		self result runCount printString, ' run, ',
		self result failureCount printString, ' failed, ',
		self result errorCount printString, ' errors'.
	Transcript crtab; show: summary.! !

!TestRunner methodsFor: 'test processing' stamp: 'jp 3/17/2003 14:00'!
showResult

	self errorLog cr;cr; show: '==== SUnit ======== Start ===='.
	self
		showResultSummary;
		showResultDefects.
	self errorLog cr; show: '==== SUnit ========== End ===='; cr.! !

!TestRunner class methodsFor: 'new-morph participation' stamp: 'nk 8/6/2003 09:54'!
prototypicalToolWindow
	^self new morphicWindow
! !

!TestRunner methodsFor: 'processing' stamp: 'nk 4/21/2002 20:41'!
runTests
	| suite |
	Cursor execute showWhile: [
		suite _ TestSuite new name: 'TestRunner Suite'.
		self selectedTests do: [ :ea | self addTestsFor: ea toSuite: suite ].
		self runSuite: suite.
	]
! !

!TestRunner class methodsFor: 'instance creation' stamp: 'nk 8/6/2003 10:40'!
windowColorSpecification
	"Answer a WindowColorSpec object that declares my preference"

	^ WindowColorSpec
		classSymbol: self name
		wording: 'TestRunner'
		brightColor: (Color r: 0.650 g: 0.753 b: 0.976)
		pastelColor: (Color r: 0.780 g: 0.860 b: 1.0)
		helpMessage: 'The Camp Smalltalk SUnit test tool'
! !

!TestRunner methodsFor: 'processing' stamp: 'nk 8/6/2003 10:51'!
addTestsFor: testName toSuite: suite 
	| cls |
	(testName indexOf: $() > 0
		ifTrue: [ Smalltalk at: #TestViaMethodCall ifPresent: [ :tvmc | tvmc addTestsFor: testName toSuite: suite] ]
		ifFalse: [cls _ testName asSymbol sunitAsClass.
			cls isAbstract
				ifTrue: [cls allSubclasses
						do: [:each | each isAbstract
								ifFalse: [each addToSuiteFromSelectors: suite]]]
				ifFalse: [cls addToSuiteFromSelectors: suite]].
	^ suite! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/12/2000 18:54'!
updateWindow: aTestResult
        aTestResult errors size + aTestResult failures size = 0
                ifTrue: [self updatePartColors: self passColor]
                ifFalse: [aTestResult errors size > 0
                                ifTrue: [self updatePartColors: self
errorColor]
                                ifFalse: [self updatePartColors: self
failColor]].
        self updatePassFail: aTestResult.
        self updateDetails: aTestResult.
        self updateFailures: aTestResult.
        self updateErrors: aTestResult! !

!TestRunner methodsFor: 'menus' stamp: 'sbw 9/26/2002 22:18'!
optionalButtonPairs
	^#(#('select all' #selectAll) #('deselect all' #deselectAll) #('toggle selections' #toggleSelections))! !

!TestRunner class methodsFor: 'class initialization' stamp: 'BG 1/15/2004 11:42'!
unload
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
         ifTrue: [TheWorldMenu unregisterOpenCommand: 'SUnit Test Runner'].

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] 
! !

!TestRunner methodsFor: 'accessing' stamp: 'nk 4/21/2002 09:36'!
listSelectionAt: index
	^selectedSuites at: index! !

!TestRunner methodsFor: 'updating' stamp: 'ar 3/1/2004 03:21'!
update: aParameter 
	"updates come in from another thread"
	(aParameter isKindOf: TestCase)
		ifTrue:[completedTests _ completedTests + 1.
				self updateProgressWatcher: aParameter printString]
		ifFalse: [ super update: aParameter ]! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 15:40'!
filterButtonLabel
	^'Filter'
! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 22:10'!
wantsOptionalButtons
	^ Preferences optionalButtons! !

!TestRunner methodsFor: 'updating' stamp: 'jp 3/17/2003 13:49'!
displayErrors: anOrderedCollection

        errors := anOrderedCollection.
        self changed: #errorsList! !

!TestRunner class methodsFor: 'new-morph participation' stamp: 'nk 8/6/2003 10:56'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | (cl respondsTo: #registerQuad:forFlapNamed:)
				ifTrue: [cl registerQuad: #(#TestRunner #prototypicalToolWindow 'Test Runner' 'The SUnit Test Runner' ) forFlapNamed: 'Tools']]! !

!TestRunner methodsFor: 'menus' stamp: 'ar 3/3/2004 23:56'!
listMenu: aMenu shifted: shiftState
	aMenu title: 'Test Cases'.
	aMenu add: 'select all' target: self selector: #selectAll.
	aMenu add: 'deselect all' target: self selector: #deselectAll.
	aMenu add: 'toggle selections' target: self selector: #toggleSelections.
	aMenu add: 'filter' target: self selector: #setFilter.
	selectedSuite > 0 ifTrue: [ | cls |
		cls _ (tests at: selectedSuite ifAbsent: ['']) copyUpTo: Character space.
		cls _ cls asSymbol.
		cls _ (Smalltalk at: cls ifAbsent: []).
		cls ifNotNil: [ | mtc |
			aMenu addLine.
			aMenu add: 'browse' target: self selector: #browse: argument: cls.
			mtc _ Smalltalk at: #MorphicTestCase ifAbsent: [ ].
			(mtc notNil and: [ cls inheritsFrom: mtc ]) ifTrue: [
				aMenu add: 'record interaction' target: self selector: #recordInteractionFor: argument: cls.
			].
		].
	].
	shiftState ifTrue: [
		aMenu addLine.
		testsList addCustomMenuItems: aMenu hand: ActiveHand.
	].
	^aMenu
! !

!TestRunner methodsFor: 'constants' stamp: 'ar 3/3/2004 00:05'!
runButtonState

 	^running! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:44'!
debugErrorTest: anInteger
        selectedErrorTest _ anInteger.  "added rew"
        selectedFailureTest _ 0.                        "added rew"
        self changed: #selectedFailureTest.             "added rew"
        self changed: #selectedErrorTest.               "added rew"
        (anInteger ~= 0)
                ifTrue: [(result errors at: anInteger) debug]! !

!TestRunner class methodsFor: 'instance creation' stamp: 'nk 8/6/2003 09:42'!
open
	"TestRunner open"
	^self new openAsMorph! !

!TestRunner class methodsFor: 'class initialization' stamp: 'md 11/14/2004 21:06'!
registerPreferences
	"Registers a preference to run abstract test classes"

	Preferences
		addPreference: #testRunnerShowAbstractClasses
		categories: #(#sunit )
		default: false
		balloonHelp: 'If true, the test testrunner shows abstract classes'
! !

!TestRunner methodsFor: 'menus' stamp: 'nk 12/19/2002 08:42'!
toggleSelections
	selectedSuites _ selectedSuites collect: [ :ea | ea not ].
	selectedSuite _ selectedSuites indexOf: true ifAbsent: [0].
	self changed: #allSelections .
! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 12/19/2002 09:11'!
buildUpperControls
	| refreshButton filterButton stopButton runOneButton runButton row bWidth listsMorph |
	row _ BorderedMorph new
				hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 borderWidth: 1;
				 borderColor: Color black;
				 layoutPolicy: ProportionalLayout new.
	row
		color: (Display depth <= 8
				ifTrue: [Color transparent]
				ifFalse: [Color gray alpha: 0.2]);
		 clipSubmorphs: true;
		 cellInset: 3;
		 borderWidth: 0.
	refreshButton _ self buildRefreshButton.
	filterButton _ self buildFilterButton.
	stopButton _ self buildStopButton.
	runOneButton _ self buildRunOneButton.
	runButton _ self buildRunButton.
	listsMorph _ self buildTestsList.
	bWidth _ 90.
	row
		addMorph: refreshButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0.33)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: filterButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.33 corner: 0 @ 0.66)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: stopButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.66 corner: 0 @ 1)
				offsets: (4 @ 2 corner: bWidth - 4 @ -2)).
	row
		addMorph: listsMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (bWidth  @ 0 corner: bWidth negated @ 0)).
	row
		addMorph: runOneButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 0.5)
				offsets: (bWidth negated + 4 @ 2 corner: -4 @ -2)).
	row
		addMorph: runButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0.5 corner: 1 @ 1)
				offsets: (bWidth negated + 4 @ 2 corner: -4 @ -2)).
	Preferences alternativeWindowLook
		ifTrue: [row color: Color transparent.
			row
				submorphsDo: [:m | m borderWidth: 2;
						 borderColor: #raised]].
	^ row! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/12/2000 18:19'!
timeSinceLastPassAsString: aResult
        (lastPass isNil or: [aResult hasPassed not]) ifTrue: [^ ''].
        ^ ', ' , (self formatTime: (Time now subtractTime: lastPass)) , '
since last Pass'! !

!TestRunner methodsFor: 'processing' stamp: 'nk 4/22/2002 07:40'!
refreshTests
	| preselected |
         selectedSuite _ 0.
        selectedFailureTest _ 0.
        selectedErrorTest _ 0.
	preselected _ Set new.
	tests with: selectedSuites do: [ :t :f | f ifTrue: [ preselected add: t ]].
       tests _ self gatherTestNames.
	selectedSuites _ tests collect: [ :ea | preselected includes: ea ].
        self changed: #tests.
        self changed: #selectedFailureTest.             "added rew"
        self changed: #selectedErrorTest.               "added rew"
        self changed: #selectedSuite.
        self refreshWindow! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/12/2000 18:57'!
updatePartColors: aColor
        passFailText isMorph
                ifTrue:
                        [passFailText color: aColor.
                        detailsText color: aColor]
                ifFalse:
                        [passFailText insideColor: aColor.
                        detailsText insideColor: aColor]! !

!TestRunner class methodsFor: 'class initialization' stamp: 'md 11/14/2004 21:02'!
initialize
	"TestRunner initialize"
	self registerInFlapsRegistry.
	self registerPreferences.
	(Preferences windowColorFor: #TestRunner) = Color white
		ifTrue: [ Preferences setWindowColorFor: #TestRunner to: (Color colorFrom: self windowColorSpecification pastelColor) ].
	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'Test Runner'.
		TheWorldMenu registerOpenCommand: {'SUnit Test Runner'. {self. #open}}].

	
! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:30'!
passColor
	^ Color green lighter! !

!TestRunner methodsFor: 'updating' stamp: 'nk 8/6/2003 09:13'!
refreshWindow
	| pc |
	pc _ self defaultBackgroundColor.
	passFailText isMorph
		ifTrue: [passFailText color: pc.
			detailsText color: pc]
		ifFalse: [passFailText insideColor: pc.
			detailsText insideColor: pc].
	self updateErrors: TestResult new.
	self updateFailures: TestResult new.
	self displayPassFail: 'N/A'.
	self displayDetails: '...'! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 14:30'!
resetColor
        ^ Color white! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/22/2002 10:53'!
successMessage
	^'succeeded'
! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 15:40'!
debugButtonLabel
        ^ 'Debug'
! !

!TestRunner methodsFor: 'updating' stamp: 'Sames 4/11/2000 18:27'!
updatePassFail: aTestResult
        | message |
        message _ aTestResult hasPassed
                                ifTrue: ['Pass']
                                ifFalse: ['Fail'].
        self displayPassFail: message! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 20:04'!
buildFilterButton
	| filterButton |
	filterButton _ PluggableButtonMorph
				on: self
				getState: nil
				action: #setFilter
				label: #filterButtonLabel.
	filterButton 
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 useRoundedCorners.
	filterButton onColor: self runButtonColor offColor: self runButtonColor.
	^ filterButton! !

!TestRunner methodsFor: 'updating' stamp: 'nk 8/6/2003 09:15'!
updateDetails: aTestResult 
	self displayDetails: aTestResult printString
			, (self timeSinceLastPassAsString: aTestResult).
	aTestResult hasPassed
		ifTrue: [lastPass _ Time now]! !

!TestRunner methodsFor: 'menus' stamp: 'KLC 1/20/2004 16:33'!
selectAll
	| sel |
	sel _ self selectedSuite.
	selectedSuites _ selectedSuites collect: [ :ea | true ].
	selectedSuites size isZero ifFalse: [
		sel isZero ifTrue: [ self selectedSuite: 1 ]
			ifFalse: [ self changed: #allSelections ]].
! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 20:18'!
stopButtonLabel
	^'Stop'
! !

!TestRunner methodsFor: 'constants' stamp: 'SSS 7/5/2000 14:08'!
debugState

        ^true! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:26'!
passFail

        ^passFail! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 2/22/2001 10:14'!
suite
        ^TestCase buildSuite! !

!TestRunner methodsFor: 'menus' stamp: 'nk 8/6/2003 09:08'!
installProgressWatcher
	| win host |
	win _ self dependents first.
	host _ win submorphs first.
	progress _ ProgressMorph label: 'Test progress'.
	progress
		borderWidth: 0;
		position: host position;
		extent: host extent;
		color: Color transparent;
		wrapCentering: #center;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	win
		addMorph: progress 
		frame: (0.0 @ 0.7 extent: 1.0 @ 0.3).
! !

!TestRunner methodsFor: 'processing' stamp: 'SSS 7/5/2000 13:59'!
debugTest! !

!TestRunner methodsFor: 'initialize' stamp: 'cwp 2/5/2004 21:34'!
gatherTestNames

	| theNames |
	theNames _ (self testCases collect: [:each | each name]) asSortedCollection.
	theNames remove: #TestViaMethodCall ifAbsent: [^ theNames].
	Smalltalk at: #TestViaMethodCall ifPresent: [ :tvmc | tvmc addClassesTo: theNames ].
	^ theNames! !

!TestRunner methodsFor: 'menus' stamp: 'nk 4/22/2002 10:50'!
addModelItemsToWindowMenu: aMenu
	aMenu addLine.
	self listMenu: aMenu shifted: false.
	aMenu addLine.
	aMenu add: 'log to Transcript' target: self selector: #showResult.
	^aMenu.
! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 19:54'!
buildLowerPanes
	| failuresList errorsList row tHeight divider |
	row _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 1;
				 borderColor: Color black;
				 layoutPolicy: ProportionalLayout new.
	self buildPassFailText.
	self buildDetailsText.
	self buildTestsList.
	failuresList _ self buildFailuresList.
	errorsList _ self buildErrorsList.
	tHeight _ 26.
	divider _ Array new: 3.
	1
		to: divider size
		do: [:index | 
			divider at: index put: BorderedSubpaneDividerMorph forBottomEdge.
			Preferences alternativeWindowLook
				ifTrue: [(divider at: index) extent: 4 @ 4;
						 color: Color transparent;
						 borderColor: #raised;
						 borderWidth: 2]].
	row
		addMorph: (passFailText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ tHeight - 1)).
	row
		addMorph: (divider at: 1)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (tHeight - 1) corner: 0 @ tHeight)).
	row
		addMorph: (detailsText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ tHeight corner: 0 @ (2 * tHeight - 1))).
	row
		addMorph: (divider at: 2)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (2 * tHeight - 1) corner: 0 @ (2 * tHeight))).
	row
		addMorph: (failuresList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0.6)
				offsets: (0 @ (2 * tHeight) corner: 0 @ -1)).
	row
		addMorph: (divider at: 3)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 0.6)
				offsets: (0 @ - 1 corner: 0 @ 0)).
	row
		addMorph: (errorsList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	^ row! !

!TestRunner methodsFor: 'initialize' stamp: 'ar 3/3/2004 00:01'!
initialize

	result := TestResult new.
	passFail := 'N/A'.
	details := '...'.
	failures := OrderedCollection new.
	errors := OrderedCollection new.
	tests := self gatherTestNames.
	selectedSuite := 0.
	selectedFailureTest := 0.
	selectedErrorTest := 0.
	selectedSuites := tests collect: [:ea | true].
	running := false.! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedErrorTest
        ^selectedErrorTest! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 22:22'!
optionalButtonRow
	| row btn |
	row _ AlignmentMorph newRow.
	row beSticky.
	row hResizing: #spaceFill.
	row wrapCentering: #center;
		 cellPositioning: #leftCenter.
	row clipSubmorphs: true.
	row cellInset: 3.
	self optionalButtonPairs
		do: [:pair | 
		btn _ PluggableButtonMorph on: self getState: nil action: pair second.
		btn useRoundedCorners; hResizing: #spaceFill; vResizing: #spaceFill; onColor: Color transparent offColor: Color transparent;
		label: pair first.
		row addMorphBack: btn
		].
	^ row! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 19:28'!
buildRunOneButton
	| runOneButton |
	runOneButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runOneTest
				label: #runOneButtonLabel.
	runOneButton color: self runButtonColor;
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 useRoundedCorners.
	runOneButton onColor: self runButtonColor offColor: self runButtonOffColor.
	^ runOneButton! !

!TestRunner methodsFor: 'menus' stamp: 'nk 8/6/2003 10:13'!
browse: aClass
	Browser fullOnClass: aClass selector: nil.! !

!TestRunner methodsFor: 'accessing' stamp: 'jp 3/17/2003 13:48'!
errorsList

        ^self errors collect: [:error | error printString]! !

!TestRunner methodsFor: 'constants' stamp: 'sbw 9/26/2002 19:31'!
errorColor
	^ Color red lighter! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/22/2002 10:53'!
failureMessage
	^'failed'
! !

!TestRunner methodsFor: 'accessing' stamp: 'nk 8/6/2003 08:36'!
failuresList

        ^self failures collect: [:failure | failure printString]! !

!TestRunner methodsFor: 'interface opening' stamp: 'sbw 9/26/2002 19:27'!
buildStopButton
	| stopButton |
	stopButton _ PluggableButtonMorph
				on: self
				getState: #stopButtonState
				action: #terminateRun
				label: #stopButtonLabel.
	stopButton color: self runButtonColor;
		hResizing: #spaceFill; vResizing: #spaceFill;
		 useRoundedCorners.
	stopButton onColor: self runButtonColor offColor: self runButtonOffColor.
	^ stopButton! !

!TestRunner methodsFor: 'interface opening' stamp: 'md 11/10/2004 13:35'!
buildPassFailText
	passFailText _ PluggableTextMorph
				on: self
				text: #passFail
				accept: nil.
	passFailText hideScrollBarsIndefinitely.
	^ passFailText! !

!TestRunner methodsFor: 'accessing' stamp: 'nk 4/21/2002 10:09'!
selectedTests
	| retval |
	retval _ OrderedCollection new.
	tests with: selectedSuites do: [ :str :sel | sel ifTrue: [ retval add: str ]].
	^retval
! !

!TestRunner methodsFor: 'menus' stamp: 'nk 12/19/2002 08:41'!
deselectAll
	selectedSuites _ tests collect: [ :ea | false ].
	selectedSuite _ 0.
      self changed: #allSelections.
 ! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 12/19/2002 09:15'!
buildTestsList
	| column offset buttonRow |
	column _ AlignmentMorph newColumn hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 layoutInset: 0;
				 borderWidth: 0;
				 borderColor: Color black;
				color: Color transparent;
				 layoutPolicy: ProportionalLayout new.
	testsList _ PluggableListMorphOfMany
				on: self
				list: #tests
				primarySelection: #selectedSuite
				changePrimarySelection: #selectedSuite:
				listSelection: #listSelectionAt:
				changeListSelection: #listSelectionAt:put:
				menu: #listMenu:shifted:.
	testsList autoDeselect: false.
	offset _ 0.
	self wantsOptionalButtons
		ifTrue: [offset _ TextStyle default lineGrid + 14 ].
	column
		addMorph: testsList
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ offset negated)).
	self wantsOptionalButtons
		ifTrue: [buttonRow _ self optionalButtonRow.
			buttonRow
				color: (Display depth <= 8
						ifTrue: [Color transparent]
						ifFalse: [Color gray alpha: 0.2]);
				 borderWidth: 0.
			Preferences alternativeWindowLook
				ifTrue: [buttonRow color: Color transparent.
					buttonRow
						submorphsDo: [:m | m borderWidth: 1;
								 borderColor: #raised]].
			column
				addMorph: buttonRow
				fullFrame: (LayoutFrame
						fractions: (0 @ 1 corner: 1 @ 1)
						offsets: (0 @ (offset - 1) negated corner: 0 @ 0))].
	^ column! !

!TestRunner methodsFor: 'constants' stamp: 'nk 4/21/2002 20:18'!
stopButtonState
	^self runButtonState not
! !

!TestRunner methodsFor: 'accessing' stamp: 'Sames 4/11/2000 17:26'!
failures

        ^failures! !

!TestRunner methodsFor: 'interface opening' stamp: 'nk 8/6/2003 08:36'!
buildFailuresList
	^PluggableListMorph
				on: self
				list: #failuresList
				selected: #selectedFailureTest
				changeSelected: #debugFailureTest:.
! !

!TestRunner methodsFor: 'processing' stamp: 'ar 3/3/2004 00:05'!
runSuite: suite
	suite addDependent: self.
	totalTests _ suite tests size.
	completedTests _ 0.
	self installProgressWatcher.
	self runWindow.
	self changed: #runTests.
	self changed: #runOneTest.
	running := true.
 	[ result _ suite run ] ensure: [
		suite removeDependent: self.
		self removeProgressWatcher.
		self updateWindow: result.
		self changed: #runTests.
		self changed: #runOneTest.
	].
! !

!Class methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:57'!
sunitName
 
        ^self name! !

Exception subclass: #TestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Preload'!

!TestFailure commentStamp: '<historical>' prior: 0!
Signaled in case of a failed test (failure). The test framework distinguishes between failures and errors. A failure is anticipated and checked for with assertions. Errors are unanticipated problems like a division by 0 or an index out of bounds ...!

!TestFailure methodsFor: 'camp smalltalk' stamp: 'ajh 2/1/2003 00:58'!
isResumable
	
	^ false! !

TestFailure subclass: #ResumableTestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Preload'!

!ResumableTestFailure commentStamp: '<historical>' prior: 0!
A ResumableTestFailure triggers a TestFailure, but lets execution of the TestCase continue. this is useful when iterating through collections, and #assert: ing on each element. in combination with methods like testcase>>#assert:description:, this lets you run through a whole collection and note which tests pass.

here''s an example:

	

	(1 to: 30) do: [ :each |
		self assert: each odd description: each printString, ' is even' resumable: true]

for each element where #odd returns <false>, the element will be printed to the Transcript. !

!ResumableTestFailure methodsFor: 'camp smalltalk' stamp: ''!
isResumable
	"Of course a ResumableTestFailure is resumable ;-)"

	^true! !

!ResumableTestFailure methodsFor: 'camp smalltalk' stamp: ''!
sunitExitWith: aValue
	self resume: aValue! !

!TestFailure methodsFor: 'camp smalltalk' stamp: 'ajh 1/24/2003 19:23'!
defaultAction

	Processor activeProcess
		debug: self signalerContext
		title: self description! !

!Exception methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 10:03'!
sunitExitWith: aValue
 
        self return: aValue! !

!BlockContext methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:56'!
sunitEnsure: aBlock
 
        ^self ensure: aBlock! !

!BlockContext methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:57'!
sunitOn: anException do: aHandlerBlock
 
        ^self on: anException do: aHandlerBlock! !

!Behavior methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:46'!
sunitAllSelectors 

        ^self allSelectors asSortedCollection asOrderedCollection! !

!Behavior methodsFor: '*sunit-preload' stamp: 'jp 3/17/2003 09:46'!
sunitSelectors
 
        ^self selectors asSortedCollection asOrderedCollection! !

Delay subclass: #SUnitDelay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Preload'!
LongTestCase initialize!
TestRunner initialize!
